/*-----------------------------------------------------------------------------
# Nome:        Servidor.java
# Finalidade: Instanciar um servidor
#
# Author:	Cesar Kallas			cesarkallas at gmx.net 			http://cesarkallas.soulivre.org
#			Renan Fernanades 	renanfernandes at gmail.com	http://renanfernandes.soulivre.org
# Copyright:   (c) 2005
# Licence:     GNU/GPL
# Pontificia Univerisidade Catolica - Puc Campinas - Brasil
#-----------------------------------------------------------------------------*/

import openchat.bd.BancoDados;
import openchat.servidor.ServidorOpenChat;
import java.io.*;

class Servidor
{
	public static void main(String Args[])
	{
		int servidorPorta = 10000, bancoDadosPorta = 3306;
		String caminho_configuracoes = new String(),
			bancoDadosIP = new String(),
			bancoDadosUsuario = new String(),
			bancoDadosSenha = new String(),
			bancoDadosEsquema = new String();

		switch(Args.length) {
			case 1: {
				if(Args[0].equals("--help"))
					System.out.println("Usage: java Servidor {arquivo de configuracoes}");
				else
					caminho_configuracoes = Args[0];
				break;
			}
			default: {
				caminho_configuracoes = "servidor.config";
			}
		}
		
		// Le configuracoes do servidor e do banco de dados
		try {
			BufferedReader configuracoes = new BufferedReader(new FileReader(new File(caminho_configuracoes)));
			servidorPorta = Integer.parseInt(configuracoes.readLine());
			bancoDadosIP = configuracoes.readLine();
			bancoDadosPorta = Integer.parseInt(configuracoes.readLine());
			bancoDadosUsuario = configuracoes.readLine();
			bancoDadosSenha = configuracoes.readLine();
			bancoDadosEsquema = configuracoes.readLine();
			configuracoes.close();
		}
		catch(IOException exceptionFile) {
			System.err.println(exceptionFile.getMessage());
			return;
		}

		// Instancia o servidor
		try {
			ServidorOpenChat servidor = new ServidorOpenChat(servidorPorta,
				bancoDadosIP,
				bancoDadosPorta,
				bancoDadosUsuario,
				bancoDadosSenha,
				bancoDadosEsquema);
		}
		catch(Exception E) {
			System.out.println("Falha ao instanciar o servidor: " + E.getMessage());
		}
	}
}